#pragma once
#include "TMGSDK_For_Audio_ApiExampleDlg.h"
#include <string>
#include <vector>
#include "VoiceParam.h"

// Real Time Voice dialog
#define COUNT_DEFAULT_PARAM_VIEW       10

class CTMGSDK_For_Audio_ApiExampleDlg;

class CTMGRealTimeAudioDlg : public CDialogEx
{
	DECLARE_DYNAMIC(CTMGRealTimeAudioDlg)

public:
	CTMGRealTimeAudioDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTMGRealTimeAudioDlg();

	void SetHostDialog(CTMGSDK_For_Audio_ApiExampleDlg *pHostDlg);
	void HandleEnterRoomCallback(const char* data);
	void HandleExitRoomCallback(const char* data);
	void HandleUserInfoUpdateCallback(const char* data);
	void HandleDisconnectRoomCallback(const char* data);
	void HandleRoomTypeChangeCallback(const char* data);
	void HandleInited();
	void HandleFetchVoiceListCallback(const char* data);
	void AppendCallbackInfo2Monitor(const std::string& callbackINfo);
// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_DIALOG_RTAUDIO };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	DECLARE_MESSAGE_MAP()

private:
	void ShowAllParamViews(bool bShow);
	void RefreshParamViews();

private:
	CEdit m_RoomId;
	CEdit m_EditMonitor;
	CComboBox m_ComBoxRoomType;
	CComboBox m_ComBoxVoiceType;
	CButton m_EnableMicCheckBox;
	CButton m_EnableSpeakerCheckBox;
	CButton m_EnableLoopbackCheckBox;
	CButton m_EnterRoomBtn;
	CButton m_ResetParamBtn;
	CTMGSDK_For_Audio_ApiExampleDlg *m_pHostDlg;




	CStatic m_ParamNameView1;
	CStatic m_ParamNameView2;
	CStatic m_ParamNameView3;
	CStatic m_ParamNameView4;
	CStatic m_ParamNameView5;
	CStatic m_ParamNameView6;
	CStatic m_ParamNameView7;
	CStatic m_ParamNameView8;
	CStatic m_ParamNameView9;
	CStatic m_ParamNameView10;

	CStatic m_ParamValueView1;
	CStatic m_ParamValueView2;
	CStatic m_ParamValueView3;
	CStatic m_ParamValueView4;
	CStatic m_ParamValueView5;
	CStatic m_ParamValueView6;
	CStatic m_ParamValueView7;
	CStatic m_ParamValueView8;
	CStatic m_ParamValueView9;
	CStatic m_ParamValueView10;

	CSliderCtrl m_ParamSliderView1;
	CSliderCtrl m_ParamSliderView2;
	CSliderCtrl m_ParamSliderView3;
	CSliderCtrl m_ParamSliderView4;
	CSliderCtrl m_ParamSliderView5;
	CSliderCtrl m_ParamSliderView6;
	CSliderCtrl m_ParamSliderView7;
	CSliderCtrl m_ParamSliderView8;
	CSliderCtrl m_ParamSliderView9;
	CSliderCtrl m_ParamSliderView10;


	CStatic* m_ParamNameViews[COUNT_DEFAULT_PARAM_VIEW];
	CStatic*  m_ParamValueViews[COUNT_DEFAULT_PARAM_VIEW];
	CSliderCtrl*  m_ParamSliderViews[COUNT_DEFAULT_PARAM_VIEW];

	CString mMonitorLog;
	std::vector<std::string> m_vVoiceList;
	std::vector<CVoiceParam> m_vParamList;
public:
	afx_msg void OnBnClickedButtonEnterroom();
	afx_msg void OnBnClickedButtonExitroom();
	afx_msg void OnBnClickedCheckEnablemic();
	afx_msg void OnBnClickedCheckEnablespeaker();
	afx_msg void OnCbnSelchangeComboRoomtype();
	afx_msg void OnCbnSelchangeComboVoicetype();
	afx_msg void OnNMCustomdrawSliderParam1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedButtonResetparam();
	afx_msg void OnBnClickedCheckEnableloopback();
};
